"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const react_router_1 = require("react-router");
const history_1 = require("history");
const utils_1 = require("./utils");
const history = history_1.createBrowserHistory();
exports.history = history;
class BrowserRouter extends React.Component {
    constructor(props) {
        super(props);
        this.history = history_1.createBrowserHistory({ basename: props.basename || '/' });
    }
    componentDidMount() {
        const { store } = this.props;
        if (store && store.dispatch) {
            this.unlisten = this.history.listen((location, action) => {
                store.dispatch({
                    type: utils_1.ROUTE_CHANGE,
                    payload: Object.assign(Object.assign({}, location), { action, query: utils_1.getQuery(location.search) })
                });
            });
            store.dispatch({
                type: utils_1.ROUTE_CHANGE,
                payload: Object.assign({ action: 'PUSH', query: {} }, window.location)
            });
        }
    }
    componentWillUnmount() {
        this.unlisten && this.unlisten();
    }
    render() {
        return React.createElement(react_router_1.Router, { history: this.history, children: this.props.children });
    }
}
exports.BrowserRouter = BrowserRouter;
//# sourceMappingURL=BrowserRouter.js.map